package cs155.hw3;


import java.awt.Color;

/**
  this class represents a 3D cylinder with open ends
 */

public class Cylinder3D extends Object3D
{
    public Point3D center;
    public Point3D direction;

    public double radius=0.0;
    public double height=0.0;

    public Cylinder3D (Point3D center, Point3D direction, double radius, double height) {
	this(center,direction,radius,height, Material.defaultMat);
    }

    public Cylinder3D (Point3D center, Point3D direction, double radius, double height, Material m)
     {
            this.center = center;
            this.direction = direction.normalize();
            this.radius = radius;
            this.height = height;
            this.insideMat = this.outsideMat = m;
     }

      
     public RayHit rayIntersect(Ray3D r) {
      Point3D P = r.p, D=r.d;
      Point3D PC = P.subtract(center);
      Point3D a = D.subtract(direction.scalarMult(direction.dot(D)));
      Point3D b = PC.subtract(direction.scalarMult(direction.dot(PC)));
      double 
       A= a.dot(a),
       B= 2*a.dot(b),
       C= b.dot(b) - radius*radius;
       double Discr = (B*B-4*A*C);
       boolean has_solution = (Discr>=0);
       if (!(has_solution)) return RayHit.NO_HIT;
       double SqrtDisc = Math.sqrt(Discr);
       double t1=(-B-SqrtDisc)/(2 *A), t2=(-B+SqrtDisc)/(2*A);
       // note t1<=t2 always

       Point3D p,V2;
       double h;
       if (t1>= epsilon) {
           p = r.atTime(t1);
	   V2 = p.subtract(center);
	   h = direction.dot(V2);
	   if ((h>= 0) && (h <= height)) return new RayHit(t1,normal(p),this);
       }
       if (t2 >= epsilon) {
           p = r.atTime(t2);
	   V2 = p.subtract(center);
	   h = direction.dot(V2);
	   if ((h>= 0) && (h <= height)) return new RayHit(t2,normal(p),this);
       }

       return RayHit.NO_HIT;
     }

      private Point3D normal(Point3D p)  { 
        Point3D p1 = p.subtract(center);
        Point3D q = p1.subtract(direction.scalarMult(direction.dot(p1))).normalize();
        return q;
     }
     
}

  

