package cs155.hw3;

/**
   This represents a material (either inside or outside on an object)
   it contains Color3D values for the emissive, ambient, diffuse, and specular reflection properties of the material
   as well as a hardness coefficient for the specular reflection.
   In addition, it specifies how much of the light coming from that point is generated by the reflection ray, and how much
   from the refraction ray (both values between 0 and 1 summing to less than 1), the remainder comes from the material itself.
 **/
public class Material {

    public Color3D emissive=Color3D.BLACK, ambient=Color3D.BLACK, diffuse=Color3D.WHITE.scale(0.5d), specular=Color3D.WHITE;
    public int hardness = 25;
    public double reflect=0.05,refract=0.0;

    public static Material defaultMat = new Material();

    public Material() {
    }

    public Material(Color3D emissive, Color3D ambient, Color3D diffuse, Color3D specular, int hardness, double reflect, double refract) {
	this.emissive = emissive;
	this.ambient = ambient;
	this.diffuse = diffuse;
	this.specular = specular;
	this.hardness = hardness;
	this.reflect = reflect;
	this.refract = refract;
    }
}
