package cs155.hw3;


import java.awt.Color;

/**
 * class represents a 3D sphere
 */

public class Sphere3D extends Object3D
{
    public Point3D center;
    public double radius=0.0;

     public Sphere3D (Point3D center, double radius, Material m)
     {
	 super();
	 this.center = center;
	 this.radius = radius;
	 this.insideMat = this.outsideMat = m;
     }

     public Sphere3D (Point3D center, double radius)
    {
	this(center,radius, Material.defaultMat);
    }

     public Sphere3D (double centerX, double centerY, double centerZ, double radius)
     {
	 this(new Point3D (centerX, centerY, centerZ), radius);
     }

      
     public RayHit rayIntersect(Ray3D r) {
      Point3D P = r.p, D=r.d;
      Point3D PC = P.subtract(center);
      double 
       t0=-1,
       A= D.dot(D),
       B= 2*D.dot(PC),
       C= PC.dot(PC) - radius*radius;
       double Discr = (B*B-4*A*C);
       boolean has_solution = (Discr>=0);
       if (!(has_solution)) return RayHit.NO_HIT;

       double SqrtDisc = Math.sqrt(Discr);
       double t1=(-B-SqrtDisc)/(2 *A), t2=(-B+SqrtDisc)/(2*A);
       // note t1<=t2 always
       if (t1>= epsilon) t0=t1;  // ray hits the outside of the sphere
       else if (t2 >= epsilon) t0=t2; // ray starts inside the sphere
       else return RayHit.NO_HIT; // sphere is behind the ray!

       Point3D p0 = r.atTime(t0);
       Point3D n0 = p0.subtract(center).normalize();
       return new RayHit(t0,n0,this);  
     }

     
}

  

