(begin
 (define m1 (Material. (Color3D. 0d 0d 0d) (Color3D. 0d 0d 0d) (Color3D. 0d 0.1d 0.8d) (Color3D. 0.1d 0.15d 0d) 150 0.1d 0.0d))
 (define m2 (Material. (Color3D. 0.0d 0.0d 0.0d) (Color3D. 0.0d 0.0d 0.0d) (Color3D. 0.5d 0.1d 0.1d) (Color3D. 0.1d 0.2d 1d) 150 0.2d 0.0d))
 (define (rotY A C) (.rotateY C (Math.toRadians A)))
 (define (rotX A C) (.rotateX C (Math.toRadians A)))
 (define (rotZ A C) (.rotateZ C (Math.toRadians A)))
 (define (tr x y z C) (.translate C (Point3D. x y z)))
 (define (sc x y z C) (.scale C x y z))

(define p0 (Point3D.   0d   0d   0d))
(define p1 (Point3D.   0d   0d 100d))
(define p2 (Point3D.   0d 100d   0d))
(define p3 (Point3D.   0d 100d 100d))
(define p4 (Point3D. 100d   0d   0d))
(define p5 (Point3D. 100d   0d 100d))
(define p6 (Point3D. 100d 100d   0d))
(define p7 (Point3D. 100d 100d 100d))

(define (triangles m L)
  (if (null? L) ()
     (cons (Triangle3D. (first L) (second L) (third L) m)
           (triangles m (rest (rest (rest L)))))))

(define (rectangle m p1 p2 p3 p4)
  (list (Triangle3D. p1 p2 p3 m) (Triangle3D. p3 p4 p1 m)))

(define tetrahedron
  (let ((G (Group3D.))
        (tris
  (triangles m1
    (list
     p0 p1 p2
     p0 p1 p3
     p1 p2 p3
     p2 p0 p3
   ))
   ))
   (for-each (lambda(x) (.add G x)) tris)
  (TransformedObject3D. G)
))

(define tri1 (Triangle3D. p0 p1 p2 m1))
(define tri1a (TransformedObject3D. tri1))

(define plane1     (Plane3D. (Point3D. 0d -100d 0d) (Point3D. 0d 1d 0d) m2))

(define cam (Camera3D. (Point3D. 0d 0d 0d)))

(define light1 (Light3D. (Point3D. 200d 500d 200d) 1d))
(define light2 (Light3D. (Point3D. -200d 500d 0d) 1d))

(define r1 (Ray3D. (Point3D. 0d 0d 10d) (Point3D. 0d 0d -1d)))

(define s0 (Sphere3D. (Point3D. 0d 0d 0d) 50d m1))
(define s0a (Sphere3D. (Point3D. 0d 0d -100d) 50d m1))
(define s1 (TransformedObject3D. s0))
(define s2 (sc 1.2d 1d 0.8d s1))

  (list 
;    (rotY -70d (rotX 45d (sc 2d 1d 0.5d s1)))
;    (sc 1d 1d 1d (rotY 70d (rotX 95d (sc 4d 1d 0.25d s1))))
;    (rotY 30d (rotZ 25d (sc 2d 1d 0.5d s1)))
;    s1
;    (tr 0d 0d 100d s1)
;    (rotY 90d (tr 0d 0d 200d (rotY 90d (rotX 90d (rotY 45d (rotZ 80d (sc 2d 1d 0.5d s1)))))))
    light1
    light2
    plane1
    s1

   (tr 0d 0d 100d (rotX 0d cam))
;    (sc 200d 200d 200d tetrahedron)
;    (sc 200d 200d 200d tetrahedron)
 )
)